LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY RAM IS
    PORT (CLK,WE : IN STD_LOGIC;
    adr: IN  STD_LOGIC_VECTOR(3 DOWNTO 0);
    di:  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
    do:  OUT STD_LOGIC_VECTOR(7 DOWNTO 0));
END RAM;

ARCHITECTURE Behavioral OF RAM IS
    TYPE ram_type IS Array(15 DOWNTO 0) OF STD_LOGIC_VECTOR (7 DOWNTO 0);
    SIGNAL sigram:ram_type:=(x"00",x"01",x"02",x"03",x"04",x"05",x"06",x"07",x"08",x"09",x"0A",x"0B",x"0C",x"0D",x"0E",x"0F");
BEGIN
    PROCESS(CLK)
        BEGIN
            IF(clk'event AND clk='1') THEN 
                IF(WE='1') THEN
                    sigram(conv_integer(adr)) <= di;
                END IF;
            END IF;
        END PROCESS;
      do <= sigram(conv_integer(adr));
END Behavioral;